"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertLinkTypeNode = exports.isLinkTypeNode = exports.linkTypeNode = void 0;
const shared_1 = require("../shared");
function linkTypeNode(name, options = {}) {
    var _a;
    return {
        kind: 'linkTypeNode',
        name: (0, shared_1.mainCase)(name),
        importFrom: (_a = options.importFrom) !== null && _a !== void 0 ? _a : 'generated',
        size: options.size,
    };
}
exports.linkTypeNode = linkTypeNode;
function isLinkTypeNode(node) {
    return !!node && node.kind === 'linkTypeNode';
}
exports.isLinkTypeNode = isLinkTypeNode;
function assertLinkTypeNode(node) {
    var _a;
    if (!isLinkTypeNode(node)) {
        throw new Error(`Expected linkTypeNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertLinkTypeNode = assertLinkTypeNode;
//# sourceMappingURL=LinkTypeNode.js.map