"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.assertStringTypeNode = exports.isStringTypeNode = exports.displayStringTypeNode = exports.stringTypeNode = void 0;
const SizeStrategy_1 = require("../shared/SizeStrategy");
function stringTypeNode(options = {}) {
    var _a, _b;
    return {
        kind: 'stringTypeNode',
        encoding: (_a = options.encoding) !== null && _a !== void 0 ? _a : 'utf8',
        size: (_b = options.size) !== null && _b !== void 0 ? _b : (0, SizeStrategy_1.prefixedSize)(),
    };
}
exports.stringTypeNode = stringTypeNode;
function displayStringTypeNode(node) {
    return `string(${node.encoding};${(0, SizeStrategy_1.displaySizeStrategy)(node.size)})`;
}
exports.displayStringTypeNode = displayStringTypeNode;
function isStringTypeNode(node) {
    return !!node && node.kind === 'stringTypeNode';
}
exports.isStringTypeNode = isStringTypeNode;
function assertStringTypeNode(node) {
    var _a;
    if (!isStringTypeNode(node)) {
        throw new Error(`Expected stringTypeNode, got ${(_a = node === null || node === void 0 ? void 0 : node.kind) !== null && _a !== void 0 ? _a : 'null'}.`);
    }
}
exports.assertStringTypeNode = assertStringTypeNode;
//# sourceMappingURL=StringTypeNode.js.map