"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAnchorAccountDiscriminator = exports.getAnchorInstructionDiscriminator = void 0;
const sha256_1 = require("@noble/hashes/sha256");
const ValueNode_1 = require("../nodes/ValueNode");
const utils_1 = require("./utils");
const getAnchorInstructionDiscriminator = (idlName) => {
    const hash = (0, sha256_1.sha256)(`global:${(0, utils_1.snakeCase)(idlName)}`).slice(0, 8);
    return (0, ValueNode_1.vList)([...hash].map((byte) => (0, ValueNode_1.vScalar)(byte)));
};
exports.getAnchorInstructionDiscriminator = getAnchorInstructionDiscriminator;
const getAnchorAccountDiscriminator = (idlName) => {
    const hash = (0, sha256_1.sha256)(`account:${(0, utils_1.pascalCase)(idlName)}`).slice(0, 8);
    return (0, ValueNode_1.vList)([...hash].map((byte) => (0, ValueNode_1.vScalar)(byte)));
};
exports.getAnchorAccountDiscriminator = getAnchorAccountDiscriminator;
//# sourceMappingURL=AnchorDiscriminator.js.map