"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnwrapInstructionArgsDefinedTypesVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const nodes_1 = require("../../nodes");
const BaseThrowVisitor_1 = require("../BaseThrowVisitor");
const Visitor_1 = require("../Visitor");
const GetDefinedTypeHistogramVisitor_1 = require("../aggregators/GetDefinedTypeHistogramVisitor");
const UnwrapDefinedTypesVisitor_1 = require("./UnwrapDefinedTypesVisitor");
class UnwrapInstructionArgsDefinedTypesVisitor extends BaseThrowVisitor_1.BaseThrowVisitor {
    visitRoot(root) {
        const histogram = (0, Visitor_1.visit)(root, new GetDefinedTypeHistogramVisitor_1.GetDefinedTypeHistogramVisitor());
        const allDefinedTypes = nodes.getAllDefinedTypes(root);
        const definedTypesToInline = Object.keys(histogram)
            // Get all defined types used exactly once as an instruction argument.
            .filter((name) => {
            var _a, _b;
            return ((_a = histogram[name].total) !== null && _a !== void 0 ? _a : 0) === 1 &&
                ((_b = histogram[name].directlyAsInstructionArgs) !== null && _b !== void 0 ? _b : 0) === 1;
        })
            // Filter out enums which are better defined as external types.
            .filter((name) => {
            const found = allDefinedTypes.find((type) => type.name === name);
            return found && !nodes.isEnumTypeNode(found.data);
        });
        // Inline the identified defined types if any.
        if (definedTypesToInline.length > 0) {
            const inlineVisitor = new UnwrapDefinedTypesVisitor_1.UnwrapDefinedTypesVisitor(definedTypesToInline);
            const newRoot = (0, Visitor_1.visit)(root, inlineVisitor);
            (0, nodes_1.assertRootNode)(newRoot);
            return newRoot;
        }
        return root;
    }
}
exports.UnwrapInstructionArgsDefinedTypesVisitor = UnwrapInstructionArgsDefinedTypesVisitor;
//# sourceMappingURL=UnwrapInstructionArgsDefinedTypesVisitor.js.map