"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UnwrapTypeDefinedLinksVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const TransformNodesVisitor_1 = require("./TransformNodesVisitor");
class UnwrapTypeDefinedLinksVisitor extends TransformNodesVisitor_1.TransformNodesVisitor {
    constructor(definedLinksType) {
        const transforms = definedLinksType.map((selectorStack) => {
            const stack = selectorStack.split('.');
            const name = stack.pop();
            return {
                selector: { kind: 'linkTypeNode', stack, name },
                transformer: (node) => {
                    nodes.assertLinkTypeNode(node);
                    if (node.importFrom !== 'generated')
                        return node;
                    const definedType = this.availableDefinedTypes.get(node.name);
                    if (definedType === undefined) {
                        throw new Error(`Trying to inline missing defined type [${node.name}]. ` +
                            `Ensure this visitor starts from the root node to access all defined types.`);
                    }
                    return definedType.data;
                },
            };
        });
        super(transforms);
        this.definedLinksType = definedLinksType;
        this.availableDefinedTypes = new Map();
    }
    visitRoot(root) {
        nodes.getAllDefinedTypes(root).forEach((definedType) => {
            this.availableDefinedTypes.set(definedType.name, definedType);
        });
        return super.visitRoot(root);
    }
}
exports.UnwrapTypeDefinedLinksVisitor = UnwrapTypeDefinedLinksVisitor;
//# sourceMappingURL=UnwrapTypeDefinedLinksVisitor.js.map