"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.UseCustomInstructionSerializerVisitor = void 0;
const nodes = __importStar(require("../../nodes"));
const shared_1 = require("../../shared");
const BaseNodeVisitor_1 = require("../BaseNodeVisitor");
const Visitor_1 = require("../Visitor");
class UseCustomInstructionSerializerVisitor extends BaseNodeVisitor_1.BaseNodeVisitor {
    constructor(map) {
        super();
        this.map = Object.entries(map).reduce((acc, [selector, options]) => ({
            ...acc,
            [(0, shared_1.mainCase)(selector)]: parseLink(selector, options),
        }), {});
    }
    visitProgram(program) {
        const newDefinedTypes = program.definedTypes;
        program.instructions.forEach((instruction) => {
            var _a;
            const options = (_a = this.map[instruction.name]) !== null && _a !== void 0 ? _a : null;
            if (!options || !options.extract)
                return;
            const newType = nodes.definedTypeNode({
                name: options.extractAs,
                data: instruction.dataArgs.struct,
                idlName: instruction.idlName,
                docs: instruction.docs,
                internal: options.extractedTypeShouldBeInternal,
            });
            newDefinedTypes.push(newType);
        });
        return nodes.programNode({
            ...program,
            definedTypes: newDefinedTypes,
            instructions: program.instructions
                .map((instruction) => (0, Visitor_1.visit)(instruction, this))
                .filter(nodes.assertNodeFilter(nodes.assertInstructionNode)),
        });
    }
    visitInstruction(instruction) {
        var _a;
        const options = (_a = this.map[instruction.name]) !== null && _a !== void 0 ? _a : null;
        if (!options)
            return instruction;
        return nodes.instructionNode({
            ...instruction,
            dataArgs: nodes.instructionDataArgsNode({
                ...instruction.dataArgs,
                link: nodes.linkTypeNode(options.name, {
                    importFrom: options.importFrom,
                }),
            }),
        });
    }
}
exports.UseCustomInstructionSerializerVisitor = UseCustomInstructionSerializerVisitor;
function parseLink(name, link) {
    const defaultOptions = {
        name: `${name}InstructionData`,
        importFrom: 'hooked',
        extract: false,
        extractAs: `${name}InstructionData`,
        extractedTypeShouldBeInternal: true,
    };
    const options = typeof link === 'boolean' ? defaultOptions : { ...defaultOptions, ...link };
    return {
        ...options,
        name: (0, shared_1.mainCase)(options.name),
        extractAs: (0, shared_1.mainCase)(options.extractAs),
    };
}
//# sourceMappingURL=UseCustomInstructionSerializerVisitor.js.map