import type { IdlTypeSet } from '../idl';
import { SizeStrategy } from '../shared';
import type { Node } from './Node';
import { TypeNode } from './TypeNode';
export type SetTypeNode = {
    readonly __setTypeNode: unique symbol;
    readonly kind: 'setTypeNode';
    readonly child: TypeNode;
    readonly size: SizeStrategy;
    readonly idlSet: 'hashSet' | 'bTreeSet';
};
export declare function setTypeNode(child: TypeNode, options?: {
    readonly size?: SizeStrategy;
    readonly idlSet?: SetTypeNode['idlSet'];
}): SetTypeNode;
export declare function setTypeNodeFromIdl(idl: IdlTypeSet): SetTypeNode;
export declare function isSetTypeNode(node: Node | null): node is SetTypeNode;
export declare function assertSetTypeNode(node: Node | null): asserts node is SetTypeNode;
