import { ImportFrom } from './ImportFrom';
export type BytesCreatedOnChain = {
    kind: 'number';
    value: number;
    includeHeader: boolean;
} | {
    kind: 'arg';
    name: string;
    includeHeader: boolean;
} | {
    kind: 'account';
    name: string;
    importFrom: ImportFrom;
    includeHeader: boolean;
} | {
    kind: 'resolver';
    name: string;
    importFrom: ImportFrom;
};
export declare const bytesFromNumber: (value: number, includeHeader?: boolean) => BytesCreatedOnChain;
export declare const bytesFromArg: (arg: string, includeHeader?: boolean) => BytesCreatedOnChain;
export declare const bytesFromAccount: (account: string, importFrom?: ImportFrom, includeHeader?: boolean) => BytesCreatedOnChain;
export declare const bytesFromResolver: (name: string, importFrom?: ImportFrom) => BytesCreatedOnChain;
