import * as nodes from '../../nodes';
import { Visitor } from '../Visitor';
export declare class GetNodeTreeStringVisitor implements Visitor<string> {
    indent: number;
    readonly separator: string;
    constructor(separator?: string);
    visitRoot(root: nodes.RootNode): string;
    visitProgram(program: nodes.ProgramNode): string;
    visitAccount(account: nodes.AccountNode): string;
    visitAccountData(accountData: nodes.AccountDataNode): string;
    visitInstruction(instruction: nodes.InstructionNode): string;
    visitInstructionAccount(instructionAccount: nodes.InstructionAccountNode): string;
    visitInstructionDataArgs(instructionDataArgs: nodes.InstructionDataArgsNode): string;
    visitInstructionExtraArgs(instructionExtraArgs: nodes.InstructionExtraArgsNode): string;
    visitDefinedType(definedType: nodes.DefinedTypeNode): string;
    visitError(error: nodes.ErrorNode): string;
    visitArrayType(arrayType: nodes.ArrayTypeNode): string;
    visitLinkType(linkType: nodes.LinkTypeNode): string;
    visitEnumType(enumType: nodes.EnumTypeNode): string;
    visitEnumEmptyVariantType(enumEmptyVariantType: nodes.EnumEmptyVariantTypeNode): string;
    visitEnumStructVariantType(enumStructVariantType: nodes.EnumStructVariantTypeNode): string;
    visitEnumTupleVariantType(enumTupleVariantType: nodes.EnumTupleVariantTypeNode): string;
    visitMapType(mapType: nodes.MapTypeNode): string;
    visitOptionType(optionType: nodes.OptionTypeNode): string;
    visitSetType(setType: nodes.SetTypeNode): string;
    visitStructType(structType: nodes.StructTypeNode): string;
    visitStructFieldType(structFieldType: nodes.StructFieldTypeNode): string;
    visitTupleType(tupleType: nodes.TupleTypeNode): string;
    visitBoolType(boolType: nodes.BoolTypeNode): string;
    visitBytesType(bytesType: nodes.BytesTypeNode): string;
    visitNumberType(numberType: nodes.NumberTypeNode): string;
    visitNumberWrapperType(numberWrapperType: nodes.NumberWrapperTypeNode): string;
    visitPublicKeyType(): string;
    visitStringType(stringType: nodes.StringTypeNode): string;
    indented(text: string): string;
}
